package com.mx.cneeds.server.datashow.client;

import com.mx.cneeds.common.dto.DepartmentDto;
import com.mx.cneeds.common.dto.JwtToken;
import com.mx.cneeds.common.dto.PageDto;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * @ClassName UserClient
 * @Author zzrdark
 * @Date 2020-03-09 15:21
 * @Description TODO
 **/
@FeignClient(name = "CNEEDS-SERVER-USER")
public interface UserClient {

    /**
     *
     * @param page
     * @param pageSize
     * @param order
     * @param orderField
     * @return
     */
    @PostMapping("/sys/func/list")
    PageDto funcList(@RequestParam Integer page,
                     @RequestParam("limit") Integer pageSize,
                     @RequestParam("sidx") String orderField,
                     @RequestParam("order") String order);

    /**
     *
     * @param page
     * @param pageSize
     * @param orderField
     * @param order
     * @return
     */
    @PostMapping("/sys/dept/list")
    PageDto deptList(@RequestParam Integer page,
                     @RequestParam("limit") Integer pageSize,
                     @RequestParam("sidx") String orderField,
                     @RequestParam("order") String order);

    /**
     *
     * @param page
     * @param pageSize
     * @param order
     * @param orderField
     * @return
     */
    @PostMapping("/sys/role/list")
    PageDto roleList(@RequestParam Integer page,
                     @RequestParam("limit") Integer pageSize,
                     @RequestParam("sidx") String orderField,
                     @RequestParam("order") String order);

    /**
     *
     * @param page
     * @param pageSize
     * @param order
     * @param orderField
     * @return
     */
    @PostMapping("/sys/user/list")
    PageDto userList(@RequestParam Integer page,
                     @RequestParam("limit") Integer pageSize,
                     @RequestParam("sidx") String orderField,
                     @RequestParam("order") String order);

    @PostMapping("/sys/dept/listAll")
    List<DepartmentDto> deptListAll();
}
