package com.mx.cneeds.server.datashow.web.system;

import com.mx.cneeds.common.converter.RequestParamterConverter;
import com.mx.cneeds.common.dto.DepartmentDto;
import com.mx.cneeds.common.dto.PageDto;
import com.mx.cneeds.common.generate.TreeToolUtils;
import com.mx.cneeds.common.result.R;
import com.mx.cneeds.common.vo.CascaderVo;
import com.mx.cneeds.common.vo.DepartmentVo;
import com.mx.cneeds.server.datashow.client.UserClient;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName SystemController
 * @Author zzrdark
 * @Date 2020-03-09 15:19
 * @Description TODO
 **/
@RestController
@Slf4j
@RequestMapping("/sys")
public class SystemController {

    @Autowired
    private UserClient userClient;

    @PostMapping("/module/list")
    public R funcList(@RequestParam(required = false) Integer page,
                      @RequestParam(required = false) Integer pageSize,
                      @RequestParam(required = false) String sort){

        String orderField = null;
        String order = null;

        if (page==null || page==0){
            page = new Integer(1);
        }
        if (pageSize==null || pageSize==0){
            pageSize = new Integer(10);
        }

        if (StringUtils.isNotEmpty(sort) && StringUtils.isNotBlank(sort.trim())){
            if (sort.contains("+")){
                order = new String("asc");
            }
            if (sort.contains("-")){
                order = new String("desc");
            }
            orderField = sort.substring(1);
            orderField = RequestParamterConverter.toLine(orderField);
        }

        PageDto pageDto = userClient.funcList(page,pageSize,orderField,order);

        return new R().put("data",pageDto);
    }

    @PostMapping("/dept/list")
    public R deptList(@RequestParam(required = false) Integer page,
                      @RequestParam(required = false) Integer pageSize,
                      @RequestParam(required = false) String sort){

        String orderField = null;
        String order = null;

        if (page==null || page==0){
            page = new Integer(1);
        }
        if (pageSize==null || pageSize==0){
            pageSize = new Integer(10);
        }

        if (StringUtils.isNotEmpty(sort) && StringUtils.isNotBlank(sort.trim())){
            if (sort.contains("+")){
                order = new String("asc");
            }
            if (sort.contains("-")){
                order = new String("desc");
            }
            orderField = sort.substring(1);
            orderField = RequestParamterConverter.toLine(orderField);
        }


        PageDto pageDto = userClient.deptList(page,pageSize,orderField,order);

        return new R().put("data",pageDto);
    }

    @PostMapping("/role/list")
    public R roleList(@RequestParam(required = false) Integer page,
                      @RequestParam(required = false) Integer pageSize,
                      @RequestParam(required = false) String sort){


        String orderField = null;
        String order = null;

        if (page==null || page==0){
            page = new Integer(1);
        }
        if (pageSize==null || pageSize==0){
            pageSize = new Integer(10);
        }

        if (StringUtils.isNotEmpty(sort) && StringUtils.isNotBlank(sort.trim())){
            if (sort.contains("+")){
                order = new String("asc");
            }
            if (sort.contains("-")){
                order = new String("desc");
            }
            orderField = sort.substring(1);
            orderField = RequestParamterConverter.toLine(orderField);
        }

        PageDto pageDto = userClient.roleList(page,pageSize,orderField,order);

        return new R().put("data",pageDto);
    }

    @PostMapping("/user/list")
    public R userList(@RequestParam(required = false) Integer page,
                      @RequestParam(required = false) Integer pageSize,
                      @RequestParam(required = false) String sort){

        String orderField = null;
        String order = null;

        if (page==null || page==0){
            page = new Integer(1);
        }
        if (pageSize==null || pageSize==0){
            pageSize = new Integer(10);
        }

        if (StringUtils.isNotEmpty(sort) && StringUtils.isNotBlank(sort.trim())){
            if (sort.contains("+")){
                order = new String("asc");
            }
            if (sort.contains("-")){
                order = new String("desc");
            }
            orderField = sort.substring(1);
            orderField = RequestParamterConverter.toLine(orderField);
        }


        PageDto pageDto = userClient.userList(page,pageSize,orderField,order);

        return new R().put("data",pageDto);
    }

    @PostMapping("/dept/add")
    public R addDept(DepartmentVo departmentVo){

        return R.ok();

    }

    @PostMapping("/dept/edit")
    public R editDept(DepartmentVo departmentVo){

        return R.ok();

    }

    @PostMapping("/dept/delete")
    public R deleteDept(@RequestParam(value = "ids",required = false) List<Long> ids,String e){

        return R.ok();

    }

    @PostMapping("/dept/listAll")
    public R selectDeptParent(){
        List<DepartmentDto> dtos = userClient.deptListAll();
        List<CascaderVo> rootList = new ArrayList<>();
        List<CascaderVo> bodyList = new ArrayList<>();
        dtos.forEach(dto -> {
            CascaderVo vo = new CascaderVo(
                    dto.getDeptId(),
                    dto.getName(),
                    dto.getParentId());
            //TODO  这里应该是自己的部门Id
            if (dto.getParentId()==0){
                rootList.add(vo);
            }else{
                bodyList.add(vo);
            }
        });
        TreeToolUtils utils =  new TreeToolUtils(rootList,bodyList);
        List<CascaderVo> result =  utils.getTree();
        return new R().put("data",result);
    }



}
